%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Andreas Franke <afranke@mathweb.org>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000-2002
%%%   Markus Moschner, 2002
%%%
%%% Last change:
%%%   $Date: 2002/08/21 23:20:14 $ by $Author: moschm $
%%%   $Revision: 1.19 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

/**
% print OpenMath objects as HTML
*/

functor

import
   %%Error
   Property
   %%System
   Browser(browse: Browse)

   Html(escapeVS:  Esc
        escapeURL: EscURL)
   at 'x-ozlib://mathweb/html/Html.ozf'
   
export
   om2Html: OM2Html
   
define
   {Property.put 'print.depth' 100}
   {Property.put 'print.width' 100}
   
   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString
   VS2BS = ByteString.make

   fun {LowerAtom VS}
      {VS2A {Map {VS2S VS} Char.toLower}}
   end
   
   Gifs = gifs('all-types':    "metamath/forall.gif"
               'forall':       "metamath/forall.gif"
               %% Symgifs alternative: "symgifs/forall.gif"
               'forall-op':    "metamath/forall.gif"
               'exists':       "metamath/exists.gif"
               %% Symgifs alternative: "symgifs/exists.gif"
               'exists-op':    "metamath/exists.gif"
               'and':           "metamath/wedge.gif"
               %% Symgifs alternative: "symgifs/and.gif"
               'or':           "metamath/vee.gif"
                %% Symgifs alternative: "symgifs/or.gif"
               'not':          "metamath/lnot.gif"
               %% Symgifs alternative:  "symgifs/not.gif"
               'equivalent':   "metamath/bigleftrightarrow.gif"
               'implies':      "metamath/bigto.gif"
               %% Symgifs alternative:  "symgifs/implies.gif"
               'union':        "metamath/cup.gif"
               %% Symgifs alternative: "symgifs/union.gif"
               'zf-union':     "metamath/cup.gif"
               'intersection': "metamath/cap.gif"
               %% Symgifs alternative: "symgifs/intrsect.gif"
               'intersect':    "metamath/cap.gif"
               'zf-intersection': "metamath/cap.gif"
               'subset':       "metamath/subseteq.gif"
               %% Symgifs alternative: "symgifs/subset.gif"
               'zf-subset':    "metamath/subseteq.gif"
               'prsubset':     "metamath/subset.gif"
               'in':           "metamath/in.gif"
               %% Symgifs alternative: "symgifs/element.gif"
               'notin':        "metamath/notin.gif"
               %% Symgifs alternative:  "symgifs/notelemn.gif"
               'empty':        "metamath/emptyset.gif"
               'emptyset':     "metamath/emptyset.gif"
               'zf-emptyset':  "metamath/emptyset.gif"
               'powerset':     "metamath/wp.gif"
               'cartesian-product': "metamath/ltimes.gif"
               'zf-product':   "metamath/ltimes.gif"
               'mapsto':       "metamath/longrightarrow.gif"
               %% Symgifs alternative: "symgifs/rarrow.gif"
               %% "cappi.gif"
               'geq':          "metamath/ge.gif"
               %% Symgifs alternative: "symgifs/geq.gif"
               'leq':          "metamath/le.gif"
               %% Symgifs alternative: "symgifs/leq.gif"
               'neq':          "metamath/ne.gif"
               %% Symgifs alternative: "symgifs/neq.gif"
               'lambda':       "metamath/lambda.gif"
               %% Symgifs alternative: "symgifs/lambda.gif"
               'i':            "metamath/iota.gif"
               %% Symgifs alternative: "symgifs/iota.gif"
               'o':            "metamath/o.gif"
               %% Symgifs alternative: "symgifs/omicron.gif"
               % lattice symbols
               'meet':         "metamath/sqcap.gif"
               'meets':        "metamath/cup.gif"
               'join':         "metamath/sqcup.gif"
               % TPS Symbols
               %%'tps.obj.compose' : "omicron.gif" /* not this gif at all */
               %%'tps.obj.maps': "rtarrow.gif" /* not useful */
               'tps.obj.diamond': "metamath/diamond.gif"
               'tps.obj.compose': "metamath/o.gif"
               'tps.obj.intersect': "metamath/cap.gif"
               'tps.obj.gvb-intersect': "metamath/cap.gif"
               'tps.obj.powerset': "metamath/wp.gif"
               'tps.obj.gvb-powerset': "metamath/wp.gif"
               'tps.obj.gvb-subset': "metamath/subseteq.gif"
               'tps.obj.gvb-union': "metamath/cup.gif"
               'tps.obj.gvb-in': "metamath/in.gif"
               'tps.obj.negation': "metamath/lnot.gif"
               'tps.obj.down-closed': "metamath/downarrow.gif"
               %% Symgifs alternative: "symgifs/dnarrow.gif"
               'tps.obj.pairintersect': "metamath/cap.gif"
               'tps.obj.pairsetunion': "metamath/cup.gif"
               'tps.obj.pairunion': "metamath/cup.gif"
               'tps.obj.subrel': "metamath/subseteq.gif"
               'tps.obj.subrelation': "metamath/subseteq.gif"
               'tps.obj.subreln2': "metamath/subseteq.gif"
               'tps.obj.setpairsintersect': "metamath/cap.gif" %% really?
               'tps.obj.setpairunion': "metamath/cup.gif"  %%really?
               'tps.obj.setintersect': "metamath/cap.gif" %% really?
               'tps.obj.setunion': "metamath/cup.gif" %% really?
               'tps.obj.in':    "metamath/in.gif"
               'tps.object.empty': "metamath/emptyset.gif"
               'tps.object.nullset': "metamath/emptyset.gif"
               'tps.obj.propersubset': "metamath/subset.gif"
               'tps.obj.meets': "metamath/cup.gif"
               'tps.obj.member': "metamath/in.gif" %% really?
               'tps.obj.subset': "metamath/subseteq.gif"
               'tps.obj.subset1': "metamath/subseteq.gif"
               'tps.obj.symdiff': "metamath/vartriangle.gif"
               %% Symgifs alternative:   "symgifs/capdelta.gif"
               'tps.obj.union':  "metamath/cup.gif"
               'tps.obj.&lt;=':  "metamath/leq.gif"
               'tps.obj.zero':   "metamath/0.gif"
               'tps.obj.two':    "metamath/2.gif"
               %% "kappa.gif"               
               %% "sum.gif"
               /*
               larrow.gif
               ltarrow.gif
               rtarrow.gif
               uparrow.gif
               updnarr.gif
               */
               % Numbers
               'zero':          "metamath/0.gif"
               'one':           "metamath/1.gif"
               'two':           "metamath/2.gif"
               'three':         "metamath/3.gif"
               'four':          "metamath/4.gif"
               'five':          "metamath/5.gif"
               'six':           "metamath/6.gif"
               'seven':         "metamath/7.gif"
               'eight':         "metamath/8.gif"
               'nine':          "metamath/9.gif"
              )
   
   InfixOpsRec = infix(
                    'plus':"+"#true
                    'minus':"-"#true
                    'times':"*"#true
                    'divide':"/"#true
                    'power':"^"#true
                    %%'leq':"<="#true
                    %%'geq':">="#true
                    'less':"<"#true
                    'lt':"<"#true
                    'greater':">"#true
                    'gt':">"#true
                    'eq':"="#false
                    '=': "="#false
                    'equivalent':gif#true
                    'equiv':"<==>"#true
                    'funtype':"->"#true
                    'setminus':"\\"#true
                    %% gifs
                    'and':gif#true
                    'or':gif#true
                    'implies':gif#true
                    'union':gif#true
                    'zf-union':gif#true
                    'intersection':gif#true
                    'zf-intersection':gif#true
                    'intersect':gif#true
                    'subset':gif#false
                    'zf-subset':gif#false
                    'cartesian-product':gif#false
                    'zf-product':gif#false
                    'mapsto':gif#true
                    'in':gif#false
                    'notin':gif#false
                    'geq':gif#true
                    'leq':gif#true
                    'neq':gif#true
                    %lattice symbols
                    'meet':gif#true
                    'meets':gif#true
                    'join':gif#true
                    %TPS symbols
                    %%'tps.obj.compose':gif#true
                    'tps.obj.leq':",="#true
                    %%'tps.obj.maps':gif#true
                    'tps.obj.compose':gif#true
                    'tps.obj.intersect':gif#true
                    'tps.obj.gvb-intersect':gif#true
                    'tps.obj.gvb-subset':gif#false
                    'tps.obj.gvb-union':gif#false
                    'tps.obj.gvb-in':gif#false
                    'tps.obj.plus-const':"+"#true %% really?
                    'tps.obj.infix-less':"<"#true %% right??
                    'tps.obj.less':"<"#true  %% also infix
                    'tps.obj.less-infix':"<"#true %% the same??
                    'tps.obj.lt':"<"#true  %%again the same?
                    'tps.obj.minus':"-"#true
                    'tps.obj.pairintersect':gif#true
                    'tps.obj.pairsetunion':gif#true
                    'tps.obj.pairunion':gif#true %% the same?
                    'tps.obj.subrel':gif#true
                    'tps.obj.subrelation':gif#true
                    'tps.obj.subreln2':gif#true
                    'tps.obj.setpairsintersect':gif#true
                    'tps.obj.setpairunion':gif#true
                    'tps.obj.setintersect':gif#true
                    'tps.obj.setunion':gif#true
                    'tps.obj.diff':"/"#true
                    'tps.obj.in':gif#true
                    'tps.obj.meets':gif#true
                    'tps.obj.member':gif#true
                    'tps.obj.setdiff':"\\"#true
                    'tps.obj.subset':gif#true
                    'tps.obj.subset1':gif#true
                    'tps.obj.symdiff':gif#true
                    'tps.obj.union':gif#true
                    'tps.obj.&lt;=':gif#true
                    'tps.obj.plus':"+"#true
                    'tps.obj.plusa':"+"#true
                    'tps.obj.timesa':"*"#true
                      )
   
   InfixOps = {Record.toDictionary InfixOpsRec}
   
   FuncDict = {NewDictionary}

   fun {Link2Sym CD Name LinkText}
      Url = "showSymbol?cd="#{EscURL CD}#"&name="#{EscURL Name} in
      {VS2BS "<a href=\""#Url#"\" style=\"text-decoration:none;\">"
      #LinkText#"</a>"}
   end

   fun {AfterLastDot VS}
      case {Reverse {List.takeWhile {Reverse {VS2S VS}} fun {$ C} C\=&. end}}
      of nil then VS
      [] S then S end
   end
   
   TYPE      = 'OMS'(cd: {VS2BS "mltt"}
                     name: {VS2BS "type"})
   
   LAMBDA    = 'OMS'(cd: {VS2BS "fns1"}
                     name: {VS2BS "lambda"})
   
   ALL_TYPES = 'OMS'(cd: {VS2BS "mltt"}
                     name: {VS2BS "all-types"})

   fun {FindType AList}
      case AList of nil then false
      [] (Key#Val)|Rest then
         case Key
         of !TYPE then Val
         else {FindType Rest}
         end
      end
   end

   fun {Var2Html OMV}
      case OMV
      of 'OMATTR'(_/*AList*/ Var) then
         {VS2S Var.name}
         /*
         case {FindType AList}
         of false then
            Var.name
         [] Type then
            "("#Var.name#" "#{WriteType Type}#")"
         end
         */
      else
         OMV.name
      end
   end
   
   fun {Lambda2Html OMBVARs Term}
      case OMBVARs of nil then Term
      [] OMV|Rest then
         "<img border=0 src=\"gifs/metamath/lambda.gif\" alt=\"lambda\" />"
         #" "#{Var2Html OMV}#" . "#{Lambda2Html Rest Term}
      end
   end
   
   fun{List2Html Xs  FuncDict}
      case Xs
      of nil then "NIL"
      [] _|_ then
         "("
         #{RecList2Html Xs  FuncDict}
         #")"
      end
   end
   
   fun{RecList2Html Term  FuncDict}
      case Term
      of nil then nil
      [] T|Tr then
         {OM2Html T}
         #if Tr == nil then ""
          else 
             " , "
             #{RecList2Html Tr FuncDict}
          end
      else Term end
   end
   /*
   proc {DoOM2Html OMObj ?X}
      X = {OM2Html OMObj}
      {Browse om2Html(OMObj X)}
   end
   */
   fun {OM2Html OMObj}
      if {HasFeature OMObj xref} then
         "<tt>&lt;&lt;xref &quot;"#{Esc OMObj.xref}#"&quot;&gt;&gt;</tt>"
      elsecase OMObj
      of nil then ""
      [] _|_ then
         {List2Html OMObj FuncDict}
      [] 'OMOBJ'(Obj) then
         {OM2Html Obj}
      [] 'OMA'('OMS'(name: "list" cd: "list1") Args...) then
         {OM2Html Args}
      [] 'OMS'(name: Name cd: CD...) then
         LinkText =
         case {CondSelect Gifs {LowerAtom Name} false}
         of false then {Esc {AfterLastDot Name}}
         [] GifFile then
            "<img border=0 src=\"gifs/"#GifFile#"\" alt=\""#{Esc Name}#"\">"
         end
      in
         {Link2Sym CD Name LinkText}
      [] 'OMV'(name: Name...) then
         {VS2S Name}
      [] 'OMA'(Functor Args...) then
         Infix = case Functor of 'OMS'(name:Name...)
                 then {Dictionary.condGet InfixOps {LowerAtom Name} unit}
                 else unit
                 end
         /*
         if {IsAtom Func} then
            {Dictionary.condGet InfixOps Func unit}
         else unit end
         */
         Func = {OM2Html Functor}
      in
         case Infix of unit then 
            Func
            #"("
            #{RecList2Html Args  FuncDict}
            #")"
         [] Op1#Parans then
            NameA = {LowerAtom Functor.name}
            Op2 =
            if Op1==gif then
               " <img border=0 src=\"gifs/"#Gifs.NameA#"\" alt=\""#NameA#"\"/> "
            else {Esc {AfterLastDot Op1}} end
            Op = {Link2Sym Functor.cd Functor.name Op2}
         in
            case Args
            of [A1 A2] then                
               if Parans then "(" else "" end
               #{OM2Html A1}
               #Op
               #{OM2Html A2}
               #if Parans then ")" else "" end
            else
               Func
               #"("
               #{RecList2Html Args  FuncDict}
               #")"
            end
         end
      [] 'OMI'(I...) then
         I
      [] 'OMF'(F...) then
         {Float.toString F}
      [] 'OMBIND'(OMS OMBVARs Term) then
         case OMS of !LAMBDA then
            {Lambda2Html OMBVARs {OM2Html Term}}
         [] !ALL_TYPES then
            %% skip all-types/kappa for now
            {OM2Html Term}
         else
            {OM2Html OMS}
            #{OM2Html OMBVARs}
            #". "
            #{OM2Html Term}
         end
      [] 'OMATTR'(_/*AList*/ Term) then
         /*
         {Browse {List.toRecord 'attr'
                  {Map AList
                   fun {$ X#Y}
                      {VS2A X.cd#":"#X.name}#{VS2BS {OM2Html Y}}
                   end}}}
         */
         {OM2Html Term}
      [] 'OMSTR'(VS) then
         {VS2BS "\""#VS#"\""}
      [] 'OME'(Sym...)=X then
         tt("ERROR &lt;&lt;"#Sym.cd#"::"#Sym.name#"&gt;&gt;"#
            if {HasFeature X 2} andthen X.2\=nil then
               " [ "#{OM2Html X.2}#" ]"
            else ''end)
      elseif {IsVirtualString OMObj} then
         {VS2A OMObj}
      else
         {Browse OMObj}
         "_" %{VS2A OMObj}
      end
   end

end
   





