%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% OpenMath.oz ; This file is part of the MathWeb system
%
%   major updates: 19.4.2001
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   MathWeb-Project                                                        
%   AG Siekmann/FB nformatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of MathWeb, see 
%   http://www.mathweb.org/mathweb
%
% See the file "LICENSE" or
%    http://www.mathweb.org/mathweb/LICENSE.html
% for information on usage and redistribution
% of this file, and for a DISCLAIMER OF ALL
% WARRANTIES.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Useful functions for OpenMath handling
%%
functor

import
   Error
   System
   Property
   Browser(browse: Browse)
   
%   Internet     at 'x-ozlib://mathweb/share/Internet.ozf'
   
   MBaseShare(cmpItemsToVS: OMObjs2Post)
   at 'x-ozlib://mathweb/mbase/export/html/Share.ozf'
   
export
   'class':     OMMatcher
   
define
   /* Lisp stuff:
   (setf omcont*symbol-cd-mapping 
    ((PLUS  . ("plus" "arith1"))
     (MINUS . ("minus" "arith1"))
     (TIMES . ("times" "arith1"))
     (POWER . ("power" "arith1"))
     (ABSVAL . ("abs" "arith1"))
     
     (=        . ("eq" "relation1"))
     (LESS     . ("lt" "relation1"))
     (GREATER  . ("gt" "relation1"))
    )
   )
   */
%    SymbolRecord = symbols('arith1': symbols('plus': "plus"
%                                             'minus': "minus"
%                                             'times': "times"
%                                             'power': "power"
%                                            ))
   {Property.put 'print.depth' 100}
   {Property.put 'print.width' 100}
   
   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString

   InfixOpsRec = infix('plus':"+"
                       'minus':"-"
                       'times':"*"
                       'power':"^"
                      )
   InfixOps = {Record.toDictionary InfixOpsRec}
   
   fun {ExceptionToVS ERROR}
      {Error.messageToVirtualString {Error.exceptionToMessage ERROR}}
   end
   class OMMatcher from BaseObject
		      
      feat
	 vars
	 app
         
      meth init(App)
	 self.vars = {NewDictionary}
         self.app = App
      end
      
      meth BuildMatcher(OMObject $)
%	 {System.show build(OMObject {IsRecord OMObject} {IsList OMObject})}
	 if {IsList OMObject} then
	    {Map OMObject fun{$ O} OMMatcher, BuildMatcher(O $) end}
	 elseif {IsRecord OMObject} then
	    Tag = {Label OMObject} in
	    if  {Member Tag ['OMS' 'OMV' 'OMSTR' 'OMI']} then OMObject
	    elseif {Member Tag ['OMOBJ' 'OMA' 'OMBIND']} then
	       {Record.map OMObject fun{$ O} OMMatcher, BuildMatcher(O $) end}
	    elsecase OMObject
	    of 'OMATTR'('OMATP'(['OMS'(cd: "kqml" name: "metatype")
				 #'OMS'(cd: "kqml" name: "metavar")])
			'OMV'(name: VarName)) then
	       NameAtom = {VS2A VarName}
	    in
	       if {Dictionary.member self.vars NameAtom} then
		  {Dictionary.get self.vars NameAtom}
	       else NewVar in
		  {Dictionary.put self.vars NameAtom NewVar}
		  NewVar
	       end
	    end
	 else OMObject end
      end
      
      meth match(X Y $)
	 XMatcher = OMMatcher, BuildMatcher(X $)
      in
%	 {Browse matching(XMatcher Y)}
         try
	    XMatcher = Y
	    {Dictionary.entries self.vars}
	 catch E then
	    {System.showInfo {ExceptionToVS E}}
            false
	 end
      end
      
   end % class OMMatcher
   
end
