%%%
%%% Author:
%%%   J"urgen Zimmer <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   J"urgen Zimmer, 2000
%%%
%%% Last change:
%%%   $Date $ by $Author $
%%%   $Revision $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
   %% first example for kqml(XML) reading and writing
   
import
   Error(exceptionToMessage messageToVirtualString)
   Property(put)
   Browser(browse: Browse)
   System
   
   XApplication at 'x-ozlib://mathweb/share/XApplication.ozf'
   File         at 'x-ozlib://mathweb/share/File.ozf'
   
   XmlParser
   at 'x-ozlib://mathweb/xmlparser/XmlParser.ozf'
   PModule
   at 'x-ozlib://mathweb/omdoc/omdoc.parser.ozf'
   SModule
   at 'x-ozlib://mathweb/omdoc/sem/omobj.sem.ozf'
   XURL
   at 'x-ozlib://mathweb/share/XURL.ozf'
   OMPrintOz
   at 'x-ozlib://mathweb/omutils/OMPrintOz.ozf'

define
   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString
   VS2BS= VirtualString.toByteString
   
   fun {ExceptionToVS Exc}
      {Error.messageToVirtualString {Error.exceptionToMessage Exc}} 
   end
   
   {Property.put 'errors.width' 100}
   {Property.put 'errors.depth' 100}
   
   AppName = 'parse-omobj'
   App     = {New XApplication.manager init}
   
   Spec = record(file(single char:&f type:string default: unit)
                 debug(single char:&d type:bool  default: false)
                )
   
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end
   
   {XmlParser.setDebug Args.debug}

   ParserModule = {XmlParser.link PModule SModule}
   
   File Content OMObject Accept
   if Args.file == unit then
      {App.showInfo "Usage: parse.exe --file <FileName> [--debug]"}
   else
      try
         Content = {File.loadVS Args.file}
      in
         {XmlParser.parseVS Content ParserModule
          'start_OMOBJ'(OMObject) Accept}
         if Accept then
            Printer = {New OMPrintOz.'class' init(app: App)}
         in
            {Browse OMObject}
            {Printer writeOMOBJ(OMObject)}
         else
            {App.showInfo "No XML encoded OMObject found."}
         end
      catch E then
         {App.showInfo {ExceptionToVS E}}
         {App.exit 1}
      end
   end
%   {App.exit 0}

end %define

      
            
