%%%
%%% Author:
%%%   J"urgen Zimmer <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   J"urgen Zimmer, 2000
%%%
%%% Last change:
%%%   $Date $ by $Author $
%%%   $Revision $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
   %% first example for kqml(XML) reading and writing
   
import
   Error(exceptionToMessage messageToVirtualString)
   Property(put)
%   Browser(browse: Browse)
   System
   
   OM2Post
   at 'x-ozlib://mathweb/omutils/OM2Post.ozf'

   TermPrinter('class': PrinterClass) at 'x-ozlib://mathweb/cs/share/Printer.ozf'

define
%   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString
%   VS2BS= VirtualString.toByteString
   
   {Property.put 'errors.width' 100}
   {Property.put 'errors.depth' 100}

   Title = "Proof Obligations"

   %% das kann man so damit machen:
   
   Printer = {New PrinterClass init(Title)}
   {Printer newTitle(Title)}
   {Printer clear}
   {Printer nextLine(_)}
   {Printer print("The proof obligations for... :")}
   {Printer nextLine(_)}
   
   OMO = 'OMBIND'(
            'OMS'(cd: "quant1" name:"forall")
            ['OMV'(name:"x")]
            'OMA'('OMS'(cd:"relation1" name:"leq")
                  ['OMA'('OMS'(cd: "arith1" name: "unary_minus")
                         [
                          'OMA'('OMS'(cd: "arith1" name: "abs")
                                ['OMV'(name: "x")]
                               )
                         ]
                        )
                   'OMA'('OMS'(cd: "transc1" name: "sin")
                         ['OMV'(name: "x")]
                        )
                  ]
                 ))
   S = {OM2Post.om2TermPrinter OMO}
   
   {System.showInfo S}
   {Printer printTerm({VS2S S})}  %% you have to send a real string!
   
end %define
