%%%
%%% Author
%%%   J"urgen Zimmer <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   J"urgen Zimmer, 2000
%%%
%%% Last change:
%%%   $Date $ by $Author $
%%%   $Revision $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
   %% first example for kqml(XML) reading and writing
   
import
   Error(exceptionToMessage messageToVirtualString)
   Property(put)
   Browser(browse: Browse)
   System
   
   OM2Post
   at 'x-ozlib://mathweb/omutils/OM2Post.ozf'

   OM2Clam(om2LClam: OM2LClam
           omdoc2LClam: OMDoc2LClam
          )
   at 'x-ozlib://mathweb/omutils/OM2LClam.ozf'

define
%   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString
%   VS2BS= VirtualString.toByteString
   
   {Property.put 'errors.width' 100}
   {Property.put 'errors.depth' 100}

   Title = "Proof Obligations"

   %% das kann man so damit machen:
   
   OMO = 'OMA'(
            'OMS'(cd: "quant1" name:"forall")
            ['OMBIND'(
                'OMS'(cd: "fns1" name:"lambda")
                ['OMV'(name:"x")]
                'OMA'('OMS'(cd:"relation1" name:"eq")
                      ['OMA'('OMS'(cd: "arith1" name: "plus")
                             [
                              'OMA'('OMS'(cd: "arith1" name: "abs")
                                    ['OMV'(name: "x")]
                                   )
                             ])
                       'OMA'('OMS'(cd: "arith1" name: "minus")
                             ['OMV'(name: "x")
                              'OMV'(name: "y")
                             ])
                      ]))])
   Times2Right = 'OMA'(
                    'OMS'(cd: "quant1" name:"forall")
                    ['OMBIND'(
                        'OMS'(cd: "fns1" name:"lambda")
                        ['OMV'(name:"x")
                         'OMV'(name:"y")]
                        'OMA'('OMS'(cd:"relation1" name:"eq")
                              ['OMA'('OMS'(cd: "my" name: "otimes")
                                     [
                                      'OMV'(name: "x")
                                      'OMA'('OMS'(cd: "nat" name: "s")
                                            ['OMV'(name: "y")])
                                     ]
                                    )
                               'OMA'('OMS'(cd: "arith1" name: "plus")
                                     ['OMV'(name: "x")
                                      'OMA'('OMS'(cd: "my" name: "otimes")
                                            ['OMV'(name: "x")
                                             'OMV'(name: "y")
                                            ])
                                     ])
                              ])
                        )])

   Test =  'OMOBJ'('OMBIND'('OMS'(cd: "quant1" name: "forall")
                            ['OMV'(name: "x")]
                            'OMBIND'('OMS'(cd: "quant1" name: "forall")
                                     ['OMV'(name: "y")]
                                     'OMA'('OMS'(cd: "relation1" name: "eq")
                                           ['OMA'('OMS'(cd: "arith1" name: "times")
                                                  ['OMV'(name: "x")
                                                   'OMA'('OMS'(cd: "arith1" name: "s")
                                                         ['OMV'(name: "y")])])
                                            'OMA'('OMS'(cd: "arith1" name: "plus")
                                                  ['OMV'(name: "x")
                                                   'OMA'('OMS'(cd: "arith1" name: "times")
                                                         ['OMV'(name: "x")'OMV'(name: "y")])])]))))
   
%   OMDoc = 'omdoc'(items: ['assertion'(type: "axiom" fmp: Test id: "assoc1")])
   OMDoc = 'omdoc'(items: ['assertion'(id: "PLUS-NAT-BASE2" type: "lemma"  theory: "NATURAL"  cmp: "another base case for recursive definition of addition."  fmp: 'FMP'(assumptions: nil 
                                                                                                                                                                         conclusion: conclusion(omobj: 'OMOBJ'('OMA'('OMS'(cd: "quant1" name: "forall")
                                                                                                                                                                                                                     ['OMBIND'('OMS'(cd: "fns1" name: "lambda")
                                                                                                                                                                                                                               'OMBVAR'(['OMATTR'(['OMATP'('OMS'(cd: "mltt" name: "type")
                                                                                                                                                                                                                                                           #'OMS'(cd: "natural" name: "num")
                                                                                                                                                                                                                                                          )
                                                                                                                                                                                                                                                  ]
                                                                                                                                                                                                                                                  'OMV'(name: "x")
                                                                                                                                                                                                                                                 ) ])'OMA'('OMS'(cd: "relation1" name: "eq")
                                                                                                                                                                                                                                                           ['OMA'('OMS'(cd: "NATURAL" name: "plus") ['OMS'(cd: "NATURAL" name: "zero") 'OMV'(name: "x") ])
 'OMV'(name: "x") ]))])))))])
   
   Assertion = 'assertion'(id: "L2" type: "conjecture" cmp: "the sequent l2."
                           fmp: 'FMP'(assumptions:
                                         ['assumption'(cmps: nil
                                                       omobj: 'OMOBJ'('OMBIND'(
                                                                         'OMS'(cd: "quant1" name: "forall")
                                                                         [['OMV'(name: "x") ]]
                                                                         'OMA'('OMS'(cd: "relation1" name: "eq")
                                                                               ['OMV'(name: "x") 'OMV'(name: "x") ]))
                                                                     ))
                                         ]
                                      conclusion:
                                         'conclusion'(cmps: nil
                                                      omobj: 'OMOBJ'('OMA'('OMS'(cd: "relation1" name: "eq")
                                                                           ['OMA'('OMS'(cd: "NATURAL" name: "times")
                                                                                  ['OMS'(cd: "NATURAL" name: "x1")
                                                                                   'OMA'('OMS'(cd: "NATURAL" name: "s")
                                                                                         ['OMS'(cd: "NATURAL" name: "y1") ])])
                                                                            'OMA'('OMS'(cd: "NATURAL" name: "plus")
                                                                                  ['OMS'(cd: "NATURAL" name: "x1")
                                                                                   'OMA'('OMS'(cd: "NATURAL" name: "times")
                                                                                         ['OMS'(cd: "NATURAL" name: "x1")
                                                                                          'OMS'(cd: "NATURAL" name: "y1") ])
                                                                                  ])
                                                                           ])))))
                                                                    
    Negation =
         'OMA'('OMS'(name: "eq" cd: "relation1")
               ['OMV'(name: "a")
                'OMA'('OMS'(name: "minus" cd: "arith1")
                      ['OMI'(~1) 'OMV'(name: "n")])])
                                                                   
  
   
%   {System.showInfo {OM2LClam OMO false false}}
%   {System.showInfo {OM2LClam Times2Right false false}}
%   {System.showInfo {OM2LClam Test false false}}
   {System.showInfo {OM2LClam Negation false false}}
%   {Browse {OMDoc2LClam OMDoc}}
%   {Browse {OMDoc2LClam Assertion}}
end %define



/**
 setWaveRules('omdoc'(items: ['assertion'(id: "PLUS-NAT-BASE2" type: "lemma"  theory: "NATURAL"  cmp: "another base case for recursive definition of addition."  fmp: 'FMP'(assumptions: nil 
 conclusion: conclusion(omobj: 'OMOBJ'('OMA'('OMS'(cd: "quant1" name: "forall") ['OMBIND'('OMS'(cd: "fns1" name: "lambda") 'OMBVAR'(['OMATTR'(['OMATP'('OMS'(cd: "mltt" name: \"type\")#'OMS'(cd: \"natural\" name: \"num\"))] 'OMV'(name: \"x\")) ])'OMA'('OMS'(cd: \"relation1\" name: \"eq\") ['OMA'('OMS'(cd: \"NATURAL\" name: \"plus\") ['OMS'(cd: \"NATURAL\" name: \"zero\") 'OMV'(name: \"x\") ])
 'OMV'(name: \"x\") ])
)]))))) ]))"
 message: "ripple('assertion'(id: \"TIMES2RIGHT\" type: \"axiom\" cmp: \"the sequent times2right.\"
 fmp: 'FMP'(assumptions: ['assumption'(cmps: nil omobj: 'OMOBJ'('OMBIND'('OMS'(cd: \"quant1\" name: \"forall\") [['OMV'(name: \"x\") ]] 'OMA'('OMS'(cd: \"relation1\" name: \"eq\") ['OMV'(name: \"x\") 'OMV'(name: \"x\") ])
)
)) ] conclusion: 'conclusion'(cmps: nil omobj: 'OMOBJ'('OMBIND'('OMS'(cd: \"quant1\" name: \"forall\") [['OMV'(name: \"x\") ]] 'OMBIND'('OMS'(cd: \"quant1\" name: \"forall\") [['OMV'(name: \"y\") ]] 'OMA'('OMS'(cd: \"relation1\" name: \"eq\") ['OMA'('OMS'(cd: \"NATURAL\" name: \"times\") ['OMV'(name: \"x\") 'OMA'('OMS'(cd: \"NATURAL\" name: \"s\") ['OMV'(name: \"y\") ])
 ])
 'OMA'('OMS'(cd: \"NATURAL\" name: \"plus\") ['OMV'(name: \"x\") 'OMA'('OMS'(cd: \"NATURAL\" name: \"times\") ['OMV'(name: \"x\") 'OMV'(name: \"y\") ])
 ])
 ])
)
)
))))
)

*/
